#![allow(bad_style)]

use hektor::*;

#[test]
fn Vec2_debug() {
  assert_eq!(&format!("{:?}", Vec2::default()), "Vec2 { x: 0.0, y: 0.0 }");
}

#[test]
fn Vec3_debug() {
  assert_eq!(
    &format!("{:?}", Vec3::default()),
    "Vec3 { x: 0.0, y: 0.0, z: 0.0 }"
  );
}

#[test]
fn Vec4_debug() {
  assert_eq!(
    &format!("{:?}", Vec4::default()),
    "Vec4 { x: 0.0, y: 0.0, z: 0.0, w: 0.0 }"
  );
}

#[test]
fn Mat2_debug() {
  assert_eq!(
    &format!("{:?}", Mat2::default()),
    "Mat2 { x_axis: (0.0, 0.0), y_axis: (0.0, 0.0) }"
  );
}

#[test]
fn Mat3_debug() {
  assert_eq!(
    &format!("{:?}", Mat3::default()),
    "Mat3 { x_axis: (0.0, 0.0, 0.0), y_axis: (0.0, 0.0, 0.0), z_axis: (0.0, 0.0, 0.0) }"
  );
}

#[test]
fn Mat4_debug() {
  assert_eq!(
    &format!("{:?}", Mat4::default()),
    "Mat4 { x_axis: (0.0, 0.0, 0.0, 0.0), y_axis: (0.0, 0.0, 0.0, 0.0), z_axis: (0.0, 0.0, 0.0, 0.0), w_axis: (0.0, 0.0, 0.0, 0.0) }"
  );
}

#[test]
fn Quat_debug() {
  assert_eq!(
    &format!("{:?}", Quat::default()),
    "Quat { a: 0.0, b: 0.0, c: 0.0, d: 0.0 }"
  );
}
