#![allow(bad_style)]

use hektor::*;

#[test]
fn Vec2_display() {
  assert_eq!(&format!("{:e}", Vec2::default()), "(0e0, 0e0)");
}

#[test]
fn Vec3_display() {
  assert_eq!(&format!("{:e}", Vec3::default()), "(0e0, 0e0, 0e0)");
}

#[test]
fn Vec4_display() {
  assert_eq!(&format!("{:e}", Vec4::default()), "(0e0, 0e0, 0e0, 0e0)");
}

#[test]
fn Mat2_display() {
  assert_eq!(
    &format!("{:e}", Mat2::default()),
    "| 0e0, 0e0 |\n| 0e0, 0e0 |"
  );
}

#[test]
fn Mat3_display() {
  assert_eq!(
    &format!("{:e}", Mat3::default()),
    "| 0e0, 0e0, 0e0 |\n| 0e0, 0e0, 0e0 |\n| 0e0, 0e0, 0e0 |"
  );
}

#[test]
fn Mat4_display() {
  assert_eq!(
    &format!("{:e}", Mat4::default()),
    "| 0e0, 0e0, 0e0, 0e0 |\n| 0e0, 0e0, 0e0, 0e0 |\n| 0e0, 0e0, 0e0, 0e0 |\n| 0e0, 0e0, 0e0, 0e0 |"
  );
}

#[test]
fn Quat_display() {
  assert_eq!(
    &format!("{:e}", Quat::default()),
    "0e0 + 0e0i + 0e0j + 0e0k"
  );
}
