#![allow(bad_style)]

use core::mem::{align_of, size_of};
use hektor::*;

#[test]
fn Vec2_size_align() {
  assert_eq!(size_of::<Vec2>(), 8);
  assert_eq!(size_of::<Vec2>(), size_of::<f32>() * 2);
  //
  assert_eq!(align_of::<Vec2>(), 4);
  assert_eq!(align_of::<Vec2>(), align_of::<f32>());
}

#[test]
fn Vec3_size_align() {
  assert_eq!(size_of::<Vec3>(), 16);
  assert_eq!(size_of::<Vec3>(), size_of::<f32>() * 4);
  assert_eq!(size_of::<Vec3>(), size_of::<Vec4>());
  //
  assert_eq!(align_of::<Vec3>(), 16);
  assert_eq!(align_of::<Vec3>(), size_of::<Vec4>());
}

#[test]
fn Vec4_size_align() {
  assert_eq!(size_of::<Vec4>(), 16);
  assert_eq!(size_of::<Vec4>(), size_of::<f32>() * 4);
  //
  assert_eq!(align_of::<Vec4>(), 16);
}

#[test]
fn Mat2_size_align() {
  assert_eq!(size_of::<Mat2>(), 16);
  assert_eq!(size_of::<Mat2>(), size_of::<f32>() * 4);
  assert_eq!(size_of::<Mat2>(), size_of::<Vec2>() * 2);
  //
  assert_eq!(align_of::<Mat2>(), 4);
  assert_eq!(align_of::<Mat2>(), align_of::<f32>());
}

#[test]
fn Mat3_size_align() {
  assert_eq!(size_of::<Mat3>(), 48);
  assert_eq!(size_of::<Mat3>(), size_of::<f32>() * 12);
  assert_eq!(size_of::<Mat3>(), size_of::<Vec3>() * 3);
  //
  assert_eq!(align_of::<Mat3>(), 16);
  assert_eq!(align_of::<Mat3>(), align_of::<Vec3>());
}

#[test]
fn Mat4_size_align() {
  assert_eq!(size_of::<Mat4>(), 64);
  assert_eq!(size_of::<Mat4>(), size_of::<f32>() * 16);
  assert_eq!(size_of::<Mat4>(), size_of::<Vec4>() * 4);
  //
  assert_eq!(align_of::<Mat4>(), 16);
  assert_eq!(align_of::<Mat4>(), align_of::<Vec4>());
}

#[test]
fn Quat_size_align() {
  assert_eq!(size_of::<Quat>(), 16);
  assert_eq!(size_of::<Quat>(), size_of::<f32>() * 4);
  //
  assert_eq!(align_of::<Quat>(), 16);
}
