#![allow(bad_style)]

use hektor::*;

#[test]
fn Vec2_display() {
  assert_eq!(&format!("{:E}", Vec2::default()), "(0E0, 0E0)");
}

#[test]
fn Vec3_display() {
  assert_eq!(&format!("{:E}", Vec3::default()), "(0E0, 0E0, 0E0)");
}

#[test]
fn Vec4_display() {
  assert_eq!(&format!("{:E}", Vec4::default()), "(0E0, 0E0, 0E0, 0E0)");
}

#[test]
fn Mat2_display() {
  assert_eq!(
    &format!("{:E}", Mat2::default()),
    "| 0E0, 0E0 |\n| 0E0, 0E0 |"
  );
}

#[test]
fn Mat3_display() {
  assert_eq!(
    &format!("{:E}", Mat3::default()),
    "| 0E0, 0E0, 0E0 |\n| 0E0, 0E0, 0E0 |\n| 0E0, 0E0, 0E0 |"
  );
}

#[test]
fn Mat4_display() {
  assert_eq!(
    &format!("{:E}", Mat4::default()),
    "| 0E0, 0E0, 0E0, 0E0 |\n| 0E0, 0E0, 0E0, 0E0 |\n| 0E0, 0E0, 0E0, 0E0 |\n| 0E0, 0E0, 0E0, 0E0 |"
  );
}

#[test]
fn Quat_display() {
  assert_eq!(
    &format!("{:E}", Quat::default()),
    "0E0 + 0E0i + 0E0j + 0E0k"
  );
}
